import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { OrderGoods, OrderGoodsParam } from './model';

/**
 * 分页查询订单商品
 */
export async function pageOrderGoods(params: OrderGoodsParam) {
  const res = await request.get<ApiResult<PageResult<OrderGoods>>>(
    '/shop/order-goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询订单商品列表
 */
export async function listOrderGoods(params?: OrderGoodsParam) {
  const res = await request.get<ApiResult<OrderGoods[]>>('/shop/order-goods', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加订单商品
 */
export async function addOrderGoods(data: OrderGoods) {
  const res = await request.post<ApiResult<unknown>>('/shop/order-goods', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改订单商品
 */
export async function updateOrderGoods(data: OrderGoods) {
  const res = await request.put<ApiResult<unknown>>('/shop/order-goods', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除订单商品
 */
export async function removeOrderGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/shop/order-goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除订单商品
 */
export async function removeBatchOrderGoods(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/shop/order-goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/shop/order-goods/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
